<?php
/**
 * $Horde: jonah/subscribe.php,v 1.51 2005/01/03 14:35:06 jan Exp $
 *
 * Copyright 2002-2005 Eric Rechlin <eric@hpcalc.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/jonah/LICENSE.
 */

@define('JONAH_BASE', dirname(__FILE__));
require_once JONAH_BASE . '/lib/base.php';
require_once JONAH_BASE . '/lib/News.php';

$news = &Jonah_News::singleton();
$channels = $news->getChannels();

/* Get form variables/initialize others. */
$actionID = Util::getFormData('actionID', -1);
$channel_id = Util::getFormData('channel_id');
$channelView = Util::getFormData('channelview', 'standard');
$error = 0;

/* Get the currently-subscribed channel list. */
$subscribed_channels = Jonah::prefDecode('channel_list', true);

$channels = $news->getChannels();
if (!empty($channel_id)) {
    $channel = $news->getChannel($channel_id);
}

switch ($actionID) {
case JONAH_SUBSCRIBE:
    $subscribed_channels[$channel_id] = array();
    $subscribed_channels[$channel_id]['channel_id'] = $channel_id;
    $subscribed_channels[$channel_id]['channel_name'] = $channel['channel_name'];
    $subscribed_channels[$channel_id]['view'] = $channelView;
    if ($channel_id && Jonah::prefEncode('channel_list', $subscribed_channels)) {
        $notification->push(sprintf(_("You have subscribed to the channel '%s'."), $channel['channel_name']), 'horde.success');
    } else {
        $notification->push(_("Channel subscription failed."), 'horde.error');
    }
    header('Location: ' . Horde::applicationUrl('subscribe.php', true));
    exit;
    break;

case JONAH_EDIT_SUBSCRIPTION:
    $channelView = $subscribed_channels[$channel_id]['view'];
    require JONAH_TEMPLATES . '/common-header.inc';
    $menu = Jonah::getMenu();
    require $registry->get('templates', 'horde') . '/menu/menu.inc';
    require JONAH_TEMPLATES . '/subscribe/edit.inc';
    require $registry->get('templates', 'horde') . '/common-footer.inc';
    exit;
    break;

case JONAH_UNSUBSCRIBE:
    if ($channel_id) {
        if (isset($subscribed_channels[$channel_id])) {
            unset($subscribed_channels[$channel_id]);
            if (Jonah::prefEncode('channel_list', $subscribed_channels)) {
                $notification->push(sprintf(_("You have unsubscribed from the channel '%s'."), $channel['channel_name']), 'horde.success');
            } else {
                $error = 1;
            }
        } else {
            $error = 1;
        }
    } else {
        $error = 1;
    }
    if ($error) {
        $notification->push(_("Channel unsubscription failed."), 'horde.error');
    }
    header('Location: ' . Horde::applicationUrl('subscribe.php', true));
    exit;
    break;

case JONAH_SAVE_CHANGES:
    if ($channel_id) {
        $subscribed_channels[$channel_id]['view'] = $channelView;
    }
    if (isset($subscribed_channels) && Jonah::prefEncode('channel_list', $subscribed_channels)) {
        $notification->push(sprintf(_("You have edited your subscription to the channel '%s'."), $channel['channel_name']), 'horde.success');
    } else {
        $notification->push(_("Channel subscription editing failed."), 'horde.error');
    }
    header('Location: ' . Horde::applicationUrl('subscribe.php', true));
    exit;
    break;

case JONAH_SHOW_CHANNEL:
    if ($channel_id) {
        if (Util::getFormData('channelview')) {
            // We're fine.
        } elseif (isset($subscribed_channels[$channel_id]['view'])) {
            $channelView = $subscribed_channels[$channel_id]['view'];
        } else {
            $channelView = 'standard';
        }
        require JONAH_TEMPLATES . '/common-header.inc';
        $menu = Jonah::getMenu();
        require $registry->get('templates', 'horde') . '/menu/menu.inc';
        echo '<form method="post" name="view" enctype="multipart/form-data" action="';
        echo Horde::selfURL() . '">';
        echo '<input type="hidden" name="actionID" value="' . JONAH_SHOW_CHANNEL . '" />';
        echo '<input type="hidden" name="channel_id" value="' . $channel_id . '" />';
        echo Jonah::buildViewWidget('channelview', $channelView, 'view.submit()');
        echo '</form><br />';
        echo $news->renderChannel($channel_id, $channelView, $channel['channel_type']);
        echo '<br />';
        echo '<form method="post" name="subscribe" enctype="multipart/form-data" action="';
        echo Horde::selfURL() . '">';
        echo '<input type="hidden" name="channel" value="' . $channel_id . '" />';
        echo '<input type="hidden" name="actionI" value="';
        if (isset($subscribed_channels[$channel_id]['view'])) {
            echo JONAH_UNSUBSCRIBE . '" />';
            echo '<input type="submit" class="button" value="' . _("Unsubscribe") . '" />';
        } else {
            echo JONAH_SUBSCRIBE . '" />';
            echo '<input type="hidden" name="channelview" value="' . $channelView . '" />';
            echo '<input type="submit" class="button" value="' . _("Subscribe") . '" />';
        }
        echo '</form>';
        require $registry->get('templates', 'horde') . '/common-footer.inc';
    } else {
        $notification->push(_("Channel display failed."), 'horde.error');
        header('Location: ' . Horde::applicationUrl('subscribe.php', true));
    }
    exit;
    break;
}

$title = _("Channel Subscriptions");
$menu = Jonah::getMenu();
require JONAH_TEMPLATES . '/common-header.inc';
require $registry->get('templates', 'horde') . '/menu/menu.inc';
require_once 'Horde/Prefs/UI.php';
require JONAH_BASE . '/config/prefs.php';
require JONAH_TEMPLATES . '/subscribe/header.inc';

if (count($channels)) {
    require JONAH_TEMPLATES . '/subscribe/column_headers.inc';
    require JONAH_TEMPLATES . '/subscribe/subscribe.inc';
    require JONAH_TEMPLATES . '/subscribe/column_footers.inc';
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
